Version 5.1:
==============
* Added: Net play ability. (prototype)
* Added: ability to show FPS and notification texts on render screen at play time.
* Added: new video options: Keep aspect ratio, Show fps and Show notifications.
* Improved: SlimDX renderer; now it can render video stretched in fullscreen mode.
* Improved: the target .net framework version changed to 4.0 for compatibility with windows xp.
* Improved: the speed limiter for more performance.
* Improved: reduced the size of state files by using zlip compressing.
* Fixed: SDL .NET renderer; crashes when attempting to switch to fullscreen.
* Fixed: INES header fixer get wrong chr count number from database.
* Fixed: when taking a snapshot, the older snap file get replaced instead of creating new one.
* Fixed: when pressing a shortcut button (like take snapshot shortcut), the input keep executing without break.
* Fixed: issue when loading state using the welcome window with fullscreen mode.
* Fixed: issue when pause/resume emulation the sound muted sometimes.
* Fixed: issue in emulation shutdown.
* Fixed: issue when toggling the speed limiter, the sound delays.
* Fixed: issue when attempting to load state that not exist, the emulation engine crashes.
* Fixed: issue when attempting to load state using the Welcome Window, sometimes the emulation engine crashes.

Version 5.0.1:
==============
* Added MLV library for ListView instead of normal listview.
* Added ability to manage columns of the listview.
* Added thumbnails view.
* Added welcome window which get shown at the program startup and give ability to play recent game or recent save state.
* Added INES format file header editor.
* Added INES files fixer tool.
* Added ability to rate each game.
* Added ability to store additional info for each rom in the beowser.
* Added zapper support to SDL .Net renderer.
* Added playd times counter which count play times of a game.
* Improved: the cache rebuild operation will not delete rom in the list if it's already exist to keep the rating, snapshot, cover....etc
* Imporved: you can open rom information of a rom even that rom is not on emulation.
* Fixed: a lot of bugs.

Version 5.0 BETA RELEASE:
==========================
This is the beta release which means it's not stable and not complete. Development in progress.
* Added support for large count of boards and mappers (almost full set)
* Added external sound channels (MMC5, Namcot106, Sunsoft5 and VRC6) 
* Added SDL .NET renderer which render using sdl dotnet library.
* Added ability to support multi-renderer.
* Added filtering tool for the browser.
* Fixed some minor bugs in the core.

Version 5.0 ALPHA RELEASE:
==========================
This is an alpha release which means it's not stable and not complete. Development in progress.

* Rewriten the emulator code and the old code replaced with optimized one.
* Cpu improved to work on instruction-clock based mode (each operation in instruction will
  clock components instead of waiting the instruction to complete before clock the instruction cycles).
* Added interrupt vector interrupting behavior in cpu.
* Added interrupt check before the last cycle behavior in cpu. 
* Improved ppu to do exact pixel timing.
* Fixed DMC sound channel.
* Added undocumented dma unit emulation.
* Added Dendy system.
* Added Turbo buttons support.
* Changed user interface to make the main window as browser.
* Added abiblity to change renderer.
* Added emulation shortcuts so that user can change shortcut keys like Save State button.

Version 4.2.0.0:
=================
* Added: user-interface multi language support.
* Fixed: APU reset timing
* Fixed: APU length halt timing 
* Fixed: APU length reload timing
* Fixed: OAM stress
* Fixed: cpu dummy reads 
* Fixed: cpu reset

Version 4.1.1.14:
=================
* Added: browser save changes button
* Fixed: Load state failure
* Fixed: sound doesn't start instantly (you have to pause then resume the emulation to start sound)
* Fixed: mapper 4 "PRG RAM protect" register
* Fixed: browser doesn't save rating until user make changes to a folder.

Version 4.1:
===========
* Added disassembly.
* Added 4 players.
* Added zapper.
* Added VSunisystem.
* Added Game Genie.
* Improved emulation speed using managed thread.
* Fixed: cpu cli latency.
* Fixed: dpm channel irqs.
* Fixed: apu clock frequency.
* Fixed: mapper 4 irq latency.
* Fixed: mapper 5 pcm external sound channel.
* Fixed: mapper 71.
* Fixed: nmi timing (immediate occurrence when enabled with VBL flag already set)

Version 4.0 [BETA]:
==================
Unstable version.
* Added option in browser for each folder that allows to show 
  files in sub folders and to let the user choose wether to
  list sub folders in the list.
* Added ability to use NES DATABASE xml files for rom information,
  detecting right tv format for game and for mappers emulation.
* Video modes removed, only Direct3D is supported now. No need
  for them since My Nes renders pixel accurate now.
* Added option to display/hide the first 8 scanline in NTSC
  format in Direct3D.
* Added state stream for state save/load files.
* General emulation code optimization.
* Added ppu sprites evulation.
* Added support for ppu emphasis and monochrome effects.
* Added ppu internal ntsc palette generator.
* Fixed ppu frame timings.
* Fixed ppu odd frames.
* Fixed nmi timing and supression.
* Fixed four-screen.
* Fixed mapper # 58 and 65.
* Minor bugs fixed.

Version 3.0 :
============
* Enjoy the new look of My Nes !! 
* Added new apu (sound emulation) engine 
* Added new sound mixer 
* Added FME7 sound channels 
* Fixed DMC sound channel 
* Fixed Noise sound channel 
* Added ability to save / load s-ram 
* Added save / load state as 
* Nes engine optimized 
* Added wave recorder 
* Fixed MMC3 (mapper # 4) IRQs. 
* Added mapper # 12, 49, 200, 201, 202, 203, 204, 205 and 213. 
* Fixed mapper # 185. 
* Added sort ability in the browser 
* Added rating ability in the browser 
* Fixed: when the user uses CTRL+X to run a rom from the recent, the emuator changes the state slot to slot X. 
* Added new commandlines/console commands.

Version 2.6.186.0 :
==================
* Fixed SlimDX Audio frequency control.
* SlimDX Video mode improved to be faster. 
* Added mapper # 185, 187, 188, 189, 226, 228, 229, 230, 231, 
  232, 233, 240, 241, 242, 243, 244, 245, 246, 248, 249 and 251

Version 2.5.1.25 :
==================
* Update SlimDX (June 2010) to SlimDX (March 2011).
* Fixed: My Nes require SlimDX SDK instead of Runtime to run.
* Fixed: When you pause the emu for a while then resume, the 
  sound delay.

Version 2.5.0.0 :
==================
* Added mapper # 47, 50, 51, 57, 58, 60, 62, 74, 76, 77,
  83, 86, 87, 88, 89, 105, 114, 115, 117, 118, 119, 133, 140, 
  142, 180, 182 and 184.
* Fixed mapper # 65, 80, 85, 90 and 113.
* Added text draw for SlimDX video mode.
* Added new option for SlimDX video mode that allows this
  mode to run faster.

Version 2.4.0.0 :
==================
* Added mapper # 5, 43, 45 and 46.
* Fixed mapper # 19, 21, 23, 24, 33, 41, 42 and 68.
* Added MMC 5 sound channels.
* Added sound dynamic buffer. (the old buffer caused glitches in windows 7)
* Added video debugger (nametables)

Version 2.3.0.0 :
==================
* Added mapper # 40, 42, 44, 67, 68 and 72.
* Added disassembly for debugging cpu and important registers.
* Fixed mapper # 41, 64, 65 and 90.
* Fixed apu's length counter timing in mode 0 and 1.
* Fixed APU irq timing.
* Fixed save state which hang sometimes due to cpu timing.
* Fixed: browser doesn't run at startup after you check that option.

Version 2.2.0.0 :
==================
* Project updated to .Net Framework 4 instead of 3.5
* DirectX video mode removed
* DirectX sound mode removed
* DirectX input removed, SlimDX take place of it.
* Fixed sound DMC channel for DAC
* Fixed APU frequency update timing
* Sound buffer instead of direct sampling, sound quality increased, 
  also no more sound missing samples
* Fixed mapper # 1 (MMC1)
* Fixed: emultor save options in save state files, so it will 
  reload them when you load state
* Fixed: the end of the name tabel displayed on the screen as a 
  black or transpert vertical line

Version 2.1.0.0 :
==================
* Added DirectX video mode
* Added DirectX sound mode
* DirectX input instead of SlimDX, so you can use My Nes without SlimDX !!
* Added sound changable modes (SlimDX and DirectX)
* Easy to switch video modes, sound modes and control profiles using the new menu items.
* Added x4, x5, x6 window sizes
* My Nes runs faster with new optimized code, using buffers for video rendering instead
  the call of RenderPixel method.
* Fixed sound timing which caused garbages in the sound playback.
* Fixed save state feature which caused My Nes to hang.
* Fixed ppu x scroll and nametable reload bits update times.

Version 2.0.0.322 :
==================
I build this version from zero, I mean that i don't use the old sourcecode from
version 1.2.5.111 although I used some of and enhance it.
The new source code brings new nes engine, it's now EXACT NES CYCLE emulator, older
versions were based on scanline, that's mean the new version is more accurate and the 
compatibility increased.
My Nes tested on test roms, and it pass most of them.

* Converted from scanline-based to cycle-based.
* compatibility increased.
* Fixed ppu scroll, timing, exact ppu nmi timing !! more accuracy.
* Fixed apu frame IRQ and timing.
* Fixed all cpu instructions.
* Added mappers # 90, 92, 93, 94, 95, 97, 112, 114 and 212.
* Fixed mappers # 4, 6, 19, 21 and 23.
* Browser improved to be faster 2X the older one.
* My Nes now boot faster than before.
* ALOT of things changed so I cannot mention them all now.

Version 1.2.5.111 :
==================
Here's the changes for the final reversion of the main version 1.x.x.x
I'm planing to recreate the whole project to convert the emulation 
from scanline-based into cycle-based PPU, hoping this will make it 
more accurate than ever.
However this version is the best of My Nes for gaming, My Nes can now
run larg count of games with good accurate, although there're a few
garbage there and there but this is the best for scanline-based emulation.
I'll be out for months, working on the version 2.x.x.x, and like always
Any help is welcomed at the project's website:
http://sourceforge.com/projects/mynes

* Fixed mmc3 (mapper 4) irq timer.
* Fixed apu noise channel freq.
* Fixed : emulator's initializing slow.

Version 1.2.0.0 :
==================
* Added HiRes (High Resolution) video mode.
* Sprite priorites improved.
* Scroll glitches fixed.
* More speed with new optimized PPU code. 

Version 1.1.0.0 :
==================
* Added mapper# 25, 26, 73, 75, 85
* Fixed mapper# 6, 17, 18.
* Fixed video size (x1, x2, Stretch).
* Zapper removed.

Version 1.0.1.23 :
==================
* Added undocumented opcodes for cpu.
* PPU VRAM Toggle fixed.

Version 1.0.0.0 :
==================
* Added Control Profiles.
* Added new sound channels (VRC6 Pulse 1 & 2, Sawtooth).
* Fixed DMC sound channel.
* Browser improved so now you can add folders in subfolders, change settings
for subfolders ...
* Fixed save/load state for sound.
* Fixed path settings when paths specified with .\

Version 0.9.2.0 :
==================
* Added Stereo / Mono sound support
* Bug Fixed : APU timing, length counter.
* Bug Fixed : can't load a rom that read only or located on DVD/CD...
* Bug Fixed : error thrown when you try to save S-RAM where there's no rom loaded. 

Version 0.9.1.1 :
==================
* Added mappers # 6, 8, 17, 19, 21, 23, 24, 81, 113.
* Added new sound mixer.
* Added sound volume controler.
* Added fullscreen toggle ability.
* Search engine in the browser improved to be faster.
* Bug fixed: roms loaded twice when you select a folder in the browser.

Version 0.9.0.122 :
==================
All My Nes rewritten in this version, the entire nes engine and the win forms
and the compatibility increased.
This time, you can call it EMULATOR !!
* The main window improved and bugs removed.
* CPU fixed (about 15 opcodes , timing).
* PPU changed to use 32-bit color instead 16-bit one.
* PPU sprite 0 hit accurate.
* Use two palettes for NTSC and PAL.
* More accurate in scanlines timing.
* Added mappers # 33, 48, 61, 65, 69, 78, 79, 80, 82, 91.
* Mapper # 16 fixed, 100%.
* Mapper # 18 fixed, 60%.
* Emulation speed increased using new optimised and clean code.
* Vertical scroll fixed (for games that use HUD in the bottom, like "The jungle Book" and 
"Power Ranger 2").
* APU (sound) now is accurate about 98% , still needs good mixer for amplifying and any glitches 
may found belongs to the mass mixer.
* Added ZAPPER support (not for all games, all i know that  "Duck Hunt" works good).
* Browser improved.
* A lot of bugs fixed and the games that didn't work work now !!
(e.g : galaxian, Battle City ...)
* Settings for each user.
* Added command lines.
* Added new debugger instructions.
* Added soft / hard reset.
* Added save S-RAM as.
* Auto save S-RAM option.

Version 0.8.2.32 :
==================
* Rectangle 1 / 2 apu sound channel fixed.
* Apu timing fixed.
* Scroll vertical fixed, Zilda works great. 
* Added : video mode "SlimDX ARGB 32-Bit" can take screenshots now.

Version 0.8.1.15 :
==================
* APU fixed (new sound engine that increase the emulator speed to 150 fps generaly when you enable the Speed Throttling.)
All sound channels rewritten and the Triangle, Noize and DMC channels work 100%. Still some small bugs with the Rectangle 1 and 2.
Now some games work (like Karateka).
* Added wave recorder that records the sound with one audio format in this version (PCM 16-bit, 44100 Hz, MONO).
* Save / Load state fixed (100% works with any game and the ability to save in different 10 state slots).
* New video mode "SlimDX ARGB 32-Bit"
* Added debugger (BETA).


Version 0.7.25.12 :
===================
* Added SlimDX insteat Managed DirectX.
* Added full Joystick support.
* Added Video modes insteat the default one.
* Added mapper # 255 for "xxx in 1" carts (above 1 Mega Bytes cart sizes)
* APU improved (the Noize channel).
* Other Core improvements.


Version 0.6.4.6 :
=================
* Add support for mappers # : 13, 15, 16, 18, 32, 34, 41 and 225.
* Browser is sizeable now (and other improvements).
* Bugs fixed:
  > Mapper # 4 IRQ timer (Teenage Mutant Ninja Turtles - Tournament Fighters game works great!!)
  > Sprite0 hit, Super Mario Bros (Orginal ver) works now.
  > VBLANK (which caused a bad scroll in some games like Castlequest and Castlevania)
  > Rename folder in the browser (when you enter nothing)


Version 0.5.2.3 :
=================
Still BETA !!
* Browser improved !!
* Added save / load state
* Sound improvement (mario sounds good)
* PAL, NTSC & speed throttling
* Frame limiter (thanks bro)


Version 0.4.1.2 :
=================
Still BETA !!
* Add sound !!


Version 0.3.1.1 : 
=================
Up To BETA !!
* PPU improved, more games are playable (more than 900 games)
* Add support for mappers #: 4, 7, 9, 10, 11, 22, 34, 64 and 66
* Draw size can be changed also video filters
* Supports 16-bit & 32-bit colors in video
* Debugger removed.


Version 0.2.1.1 : 
=================
Still Alpha !!
* PPU improved, more games are playable. 
* Supports for rar,zip and 7z archives. 
* Debugger !!
* Switch between draw mode


Version 0.1.1.0 :
=================
ALPHA first release.